% ----- MAIN PROGRAM: ENCRYPTION USING ElGamal ECC ALGORITHM
% ----- BASED ON ELLIPTIC CURVE CRYPTOGRAPHY
% ----- Update on Sept 13 2014. Added One Line Command on the firs line:
% ----- 			clear all;
%==================================================================
clear all; % added since Sept, 3rd 2014
p=input('\nPrime p: ');
A=input('\nCoefficient  A of  Y^2 = X^3 + AX + B: ');
B=input('\nConstans B of Y^2 = X^3 + AX + B: ');
G=input('\nBasic point (G): ');
Ng=input('\nOrder Basic Point (Ng): ');
e=input('\nnumber of experiments point representation: ');
PB=input('\nPublic Key (PB): ');
fprintf('\nStart and End your message with single quote ');
fprintf('\n==== Write your messages (plaintext) here ====\n');
pesan=input('');
if(isnumeric(pesan)==1)
    pesan=num2str(pesan);
end
lpesan=length(pesan);
d2b=des2bin(p);
nkunci=length(d2b{1});
bpesan=ceil(nkunci/8)-1;
ipesan=ceil(lpesan/bpesan);
akhir=0;
if (lpesan>bpesan)
    for ips=1:1:ipesan
        if (ips<ipesan)
            awal=akhir+1;
            akhir=bpesan*ips;
            plain{ips}=pesan(awal:akhir);
        else
            plain{ips}=pesan(akhir+1:lpesan);
        end
        p2n(ips)=eccplain2num(plain{ips});
        PM=eccnum2titik(p,A,B,p2n(ips),e);
        n2t{ips}=PM;
    end
    for nti=1:1:length(n2t)
		K=randi([1, Ng-1],1);
        PC{nti}=eccenk(p,A,G,Ng,PB,n2t{nti},K);
    end
elseif (lpesan<=bpesan)
    p2n=eccplain2num(pesan);
    n2t=eccnum2titik(p,A,B,p2n,e);
	K=randi([1, Ng-1],1);
    PC=eccenk(p,A,G,Ng,PB,n2t,K);
end
fprintf('\nBNumber of experiments point representation : %.0f ',e);
fprintf('\n################# CHIPERTEXT ##################');
fprintf('\n[');
for prn=1:1:length(PC)
    fprintf('%.0f ',PC{prn}(1,:));
    fprintf('\b;');
end
fprintf('\b]');
fprintf('\n\n########## Encryption of ElGamal ECC ##########');
fprintf('\n\n***************** INPUT  *****************');
fprintf('\n   1. Prime number Prima %.0f : ',p);
fprintf('\n   2. Coefficient and Constans of Y^2 = X^3 + AX +B');
fprintf('\n          A = %.0f',A);
fprintf('\n          B = %.0f',B);
fprintf('\n   3. Basic Point G :(%.0f , %.0f)',G(1),G(2));
fprintf('\n   4. Order Basic Point Ng : %.0f',Ng);
fprintf('\n   5. number of experiments point representation (e): %.0f',e);
fprintf('\n   6. Public Key (PB) : (%.0f , %.0f)',PB(1),PB(2));
fprintf('\n   7. --------------- Plaintext-----------------------');
fprintf('\n      %s',pesan);
fprintf('\n\n********* OUTPUT PROGRAM (Chipertext) ************\n');
for prn=1:1:length(PC)
    fprintf('%12.0f ',PC{prn}(1,:));
    fprintf(';\n');
end
fprintf('\n##################################################'); 