% Function to search for a basic point (G) and the order of the basic point (Ng).
% NE is the order of the elliptic group Ep (A, B) over Fp.
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% B : Contants B in this equation y^2 = x^3 + Ax + B (input parameter)
% Ne : order of Elliptic curve Group (input parameter)
% Ng: order basic Point (output)
% G : Basic Point (output)
function [Ng,G]=eccbasic(p,A,B,Ne)
ulang=1;i=0;
while(ulang==1)
    i=i+1;
    PG=eccpoint(p,A,B);
    Ng=eccordpoint(p,A,PG);
    if (Ng>=Ne)
        G=PG;
        ulang=0;
        break;
    end
    if (i>Ne)
        ulang=0;
        G=PG;
        fprintf(' \n(%.0f,%.0f) is not Basic Point ');
        break;
    end
end