% Function to encrypt one point representation
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% G : Basic Points
% Ng : order basic points
% PB : Public key
% PM : Point representaion (this will be encrypted)
% k : scalar multiplication
% PC : Chipertext pair of points
function PC=eccenk(p,A,G,Ng,PB,PM,k)
P1=eccaddsub(p,A,k,G);
P21=eccaddsub(p,A,k,PB);
P2=eccadd(p,A,PM,P21);
PC=[P1(1) P1(2) P2(1) P2(2)];