% Function to calculate (a+b) mod p
% a : integer number, and 'a' is element of Prime Finite Field (Fp)
%  b : integer number, and 'b' is element of Prime finite field (Fp)
% p : prime number
% addp : Result of (a+b) mod p
function addp=eccfadd(a,b,p)
a=mod(a,p);
b=mod(b,p);
addp=mod(a+b,p);