% Function to convert from numeric into plaintext
% m : numeric (input parameter)
% psn : plaintext (output parameter)
function psn=eccnum2plain(m)
mbin=des2bin(m);
mblen=length(mbin{1});
if (mod(mblen,8)==0)
    mlen=mblen/8;
elseif (mod(mblen,8)~=0)
    mlen=(floor(mblen/8))+1;
end
i=0;
for ml=mlen:-1:1
    maxps=mblen-(8*i);
    if (ml>1)
        minps=maxps-7;
    else
        minps=1;
    end
    psbin=mbin{1}(minps:maxps);
    psn(ml)=char(bin2des(psbin));
    i=i+1;
end