% Function to find Order Elliptic Group
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% B : Constants Elliptic Curve of B in this equation y^2 = x^3 + Ax + B (input parameter)
% Ne : Order Elliptic Group
function Ne=eccordgrup(p,A,B)
Ne=1;
for x=0:1:p-1   
    sqry=eccfy2(p,A,B,x);
    takar=eccfpangkat(sqry,(p-1)/2,p);
    if(takar==1)
        if (sqry==0)
            Ne=Ne+1;
        else
            Ne=Ne+2;
        end
    end
end