% Function to generate one elliptic curve point in Elliptic group
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% B : Constants Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% PG : Elliptic curve point
function PG=eccpoint(p,A,B)
ulang=1;
while (ulang==1)
    Gx=randi(1,1,[0,p-1]);
    sqry=eccfy2(p,A,B,Gx);
    takar=eccfpangkat(sqry,(p-1)/2,p);
    if (takar==1)
        Gy=eccfakar(sqry,p);
        ulang=0;
        break;
    end
end
PG=[Gx Gy(1)];