% Function to decrypt one chipertext pair of points into Point representation
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^2 + Ax + B (input parameter)
% V : Private key. (input parameter)
% PC : Chipertext pair of points (input parameter)
% PM : Point representation
function PM=eccdek(p,A,V,PC)
C{1}=PC(1:2);
C{2}=PC(3:4);
M1=eccaddsub(p,A,V,C{1});
PM=eccsub(p,A,C{2},M1);