% Function to find (calculate) invers in mod p
% c : integer number, and 'c' is element of Prime Finite Field (Fp)
% p : prime number
% invc : Result of (invers c )  mod p'
function invc=eccfinv(c,p)
c=mod(c,p);
a=[1 0 p];
b=[0 1 c];
ulang=1;
while (ulang==1)
    if (b(3)==0)
        invc=[];
		ulang=0;
        break;
    end
    if (b(3)==1)
        invc=mod(b(2),p);
        ulang=0;
        break;
    end
    if (ulang~=0)
        q=floor(a(3)/b(3));
        t=[a(1)-q*b(1) a(2)-q*b(2) a(3)-q*b(3)];
        a=b;
        b=t;
    end
end