% Function to calculate (k * a) mod p
% k : integer number, and 'k' is element of Prime Finite Field (Fp)
%  a : integer number, and 'a' is element of Prime finite field (Fp)
% p : prime number
% ka : Result of (k * a) mod p
function ka=eccfkali(k,a,p)
if (k<0) 
    k=mod(k,p);
end
u=eccnaf(k);
ka=0;
for j=length(u):-1:1
    ka=eccfadd(ka,ka,p);
    if(u(j)==1)
        ka=eccfadd(ka,a,p);
    elseif (u(j)==-1)
        nega=mod(-a,p);
        ka=eccfadd(ka,nega,p);
    end
end