% Function to calculate (a^k) mod p
% a : integer number, and 'a' is element of Prime Finite Field (Fp)
% k : integer number, and 'k' is element of Prime finite field (Fp)
% p : prime number
% ak : Result of (a^k) mod p
function ak=eccfpangkat(a,k,p)
a=mod(a,p);
if(k<0)
    ku=-k;
else
    ku=k;
end
if(a==0)
    ak=0;
elseif (k==0)
    ak=1;
else
    u=eccnaf(ku);
    ak=1;
    for j=length(u):-1:1
        ak=eccfkali(ak,ak,p);
        if(u(j)==1)
            ak=eccfkali(ak,a,p);
        elseif (u(j)==-1)
            nega=eccfinv(a,p);
            ak=eccfkali(ak,nega,p);
        end
    end
    if (k<0)
        ak=eccfinv(ak,p);
    end
end