% Function to calculate and slove elliptic curve equation Y^3 = X^3 + A*X + B
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% B : Constants Elliptic Curve of B in this equation y^2 = x^3 + Ax + B (input parameter)
% x : value of variable 'x' in this equation y^2 = x^3 + Ax + B (input parameter)
% sqry : result of Y from this equation y^2 = x^3 + Ax + B (output parameter)
function sqry=eccfy2(p,A,B,x)
y1=eccfpangkat(x,3,p);
y21=eccfkali(A,x,p);
y2=eccfadd(y1,y21,p);
sqry=eccfadd(y2,B,p);