% Function to find A and B on elliptic curve equation Y^3 = X^3 + A*X + B
% such that  (4*(A^3 ))  + ( 27 * (B^2) )  not equal with 0.
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (output parameter)
% B : Constants Elliptic Curve of B in this equation y^2 = x^3 + Ax + B (output parameter)
function [A,B]=ecckurv(p)
fprintf('\nPersamaan kurva elliptiknya Y^2 = X^3 + Ax +B');
fprintf('\n1. Nilai A dan B ditentukan sendiri');
fprintf('\n2. Nilai A dan B ditentukan oleh komputer');
pilih=0;
while ((pilih~=1) && (pilih~=2))
    pilih=input('\nPilih 1 atau 2 : ');
end
ulang=1;
while (ulang==1)
    if (pilih==1)
        fprintf('\n-%.0f<=A<=%.0f, masukkan nila A = ',p-1,p-1); 
        A=input('');
        fprintf('\n-%.0f<=B<=%.0f, masukkan nila B = ',p-1,p-1); 
        B=input('');
    elseif (pilih==2)
        rAB=randi(1,2,[-(p-1),p-1]);
        A=rAB(1);
        B=rAB(2);
    end        
    syrt11=eccfpangkat(A,3,p);
    syrt1=eccfkali(4,syrt11,p);
    syrt21=eccfpangkat(B,2,p);
    syrt2=eccfkali(27,syrt21,p);
    syarat=eccfadd(syrt1,syrt2,p);
    if ( (abs(A)<=p-1) & (abs(B)<=p-1) & (syarat~=0) )
        ulang=0;
    end
end