% Function to calculate negative of elliptic curve point
% p : rime number value (input parameter)
% PP : a elliptic curve point (input parameter)
% negP : negative of Point P or -PP
function negP=eccneg(p,PP)
if ((PP~='O') & (PP~='o'))
    negP(1)=PP(1);
    negP(2)=mod(-PP(2),p);
else
    negP='O';
end