% Function to convert from numeric into elliptic curve point
% p : rime number value (input parameter)
% A : Coefficient Elliptic Curve of A in this equation y^2 = x^3 + Ax + B (input parameter)
% m : numeric (input parameter)
% e : Number of experiments point representation (input paramter)
% PM : Elliptic curve point
function PM=eccnum2titik(p,A,B,m,e)
while ((m*e>=p)|(m<0)|(e<1))
    fprintf('\ne>=0 and m=%.0f >= 0 and m*e=%.0f * e < %.0f ',m,m,p);
    e=input('\nBanyaknya Percobaan Representasi Titik (e): ');
end
%fprintf('\n   numerik into point representation'); 
%fprintf('\n=========================================================\n');
x=eccfkali(m,e,p);
ulangxy=1;
while (ulangxy==1)
    j=randi([0, e-1],1);
    xj=eccfadd(x,j,p);
    sj=eccfy2(p,A,B,xj);
    akar=eccfakar(sj,p);
    if ((akar~=0) & (xj~=0))
        ulangxy=0;
        break
    end
end
PM=[xj akar(1)];
%fprintf('\n   One random Point representation (%.0f,%.0f)\n',PM(1),PM(2));